###################################################
### chunk number 1: 
###################################################
#line 57 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
options(width = 80)
library("registry")


###################################################
### chunk number 2: 
###################################################
#line 123 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
library(registry)
R <- registry()
print(R)


###################################################
### chunk number 3: 
###################################################
#line 142 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
checkAge <- function(x) stopifnot(is.na(x) || x > 0 && x < 100)


###################################################
### chunk number 4: 
###################################################
#line 148 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
checkPhone <- function(x) stopifnot(!is.na(x$mobile) || !is.na(x$home))


###################################################
### chunk number 5: 
###################################################
#line 154 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R <- registry(registry_class = "Addressbook", entry_class = "Address",
              validity_FUN = checkPhone)


###################################################
### chunk number 6: 
###################################################
#line 159 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
print.Addressbook <-
function(x, ...) {
    writeLines(sprintf("An address book with %i entries.\n", length(x)))
    invisible(x)
}
print(R)


###################################################
### chunk number 7: 
###################################################
#line 171 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_field("last", type = "character", is_key = TRUE, index_FUN = match_partial_ignorecase)
R$set_field("first", type = "character", is_key = TRUE, index_FUN = match_partial_ignorecase)


###################################################
### chunk number 8: 
###################################################
#line 176 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_field("address", type = "character")


###################################################
### chunk number 9: 
###################################################
#line 182 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_field("mobile", type = "character")
R$set_field("home", type = "character")


###################################################
### chunk number 10: 
###################################################
#line 188 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_field("age", type = "integer", validity_FUN = checkAge)


###################################################
### chunk number 11: 
###################################################
#line 193 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_field("type", type = "character",
            alternatives = c("Business", "Private"),
            default = "Business")


###################################################
### chunk number 12: 
###################################################
#line 199 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$get_field("type")


###################################################
### chunk number 13: 
###################################################
#line 207 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_entry(last = "Smith", first = "Mary", address = "Vienna",
            home = "734 43 34", type = "Private", age = 44L)
R$set_entry(last = "Smith", first = "Peter", address = "New York",
            mobile = "878 78 87")


###################################################
### chunk number 14: 
###################################################
#line 214 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_entry("Myers", "John", "Washington", "52 32 34", "898 89 99",
            33L, "Business")


###################################################
### chunk number 15: 
###################################################
#line 219 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
TRY <- function(expr) tryCatch(expr, error = print)
TRY(R$set_entry(last = "Smith", first = "Mary"))
TRY(R$set_entry(last = "Miller", first = "Henry"))
TRY(R$set_entry(last = "Miller", first = "Henry", age = 12.5))
TRY(R$set_entry(last = "Miller", first = "Henry", age = 999L))


###################################################
### chunk number 16: 
###################################################
#line 227 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$get_entry(last = "Smith", first = "mar")


###################################################
### chunk number 17: 
###################################################
#line 232 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
print.Address <- function(x) with(x,
    writeLines(sprintf("%s %s, %s; home: %s, mobile: %s; age: %i (%s)", first, last, address, home, mobile, age, type)))
R$get_entry(last = "Smith", first = "mar")


###################################################
### chunk number 18: 
###################################################
#line 242 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R[["Myers"]]


###################################################
### chunk number 19: 
###################################################
#line 247 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$set_entry(last = "Frears", first = c("Joe", "Jonathan"),
            address = "Washington", home = "721 42 34")


###################################################
### chunk number 20: 
###################################################
#line 252 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
identical(R[["Frears", "Jonathan"]], R[["Frears", "Joe"]])


###################################################
### chunk number 21: 
###################################################
#line 259 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$get_entries("Smith")


###################################################
### chunk number 22: 
###################################################
#line 263 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$grep_entries("Priv")


###################################################
### chunk number 23:  eval=FALSE
###################################################
## #line 267 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
## R$get_entries()
## R[]


###################################################
### chunk number 24: 
###################################################
#line 272 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
summary(R)


###################################################
### chunk number 25: 
###################################################
#line 277 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R[["Smith", "Peter"]]
R$modify_entry(last = "Smith", first = "Peter", age = 22L)
R[["Smith", "Peter"]]


###################################################
### chunk number 26: 
###################################################
#line 283 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$delete_entry(last = "Smith", first = "Peter")
R[["Smith", "Peter"]]


###################################################
### chunk number 27: 
###################################################
#line 295 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$seal_entries()
TRY(R$delete_entry("Smith", "Mary"))
R$set_entry(last = "Slater", first = "Christian", address = "Boston",
            mobile = "766 23 88")
R[["Slater"]]


###################################################
### chunk number 28: 
###################################################
#line 303 "d:/Rcompile/CRANpkg/local/2.12/registry/inst/doc/registry.Rnw"
R$get_permissions()
R$restrict_permissions(delete_entries = FALSE)
TRY(R$delete_entry("Slater"))
R$modify_entry(last = "Slater", first = "Christian", age = 44L)
R[["Slater"]]


